#include <iostream>
#include <vector>
#include <set>
#include <string.h>
#include <algorithm>

using namespace std;

string normalize(string tel) {
    string normalizeTel = "";
    for(size_t i = 0; i < tel.size(); ++i) {
        if(tel[i] != '*')
            normalizeTel += tel[i];
        else {
            for (size_t j = 0; j < ((9-i)-(tel.size() - (i + 1))); ++j) {
                normalizeTel += '?';
            }
        }
    }
    return normalizeTel;
}

int main (){
    int numOfTels;


    cin >> numOfTels;

    vector<string> tels(numOfTels);
    string tmp;
    for (int i = 0; i < numOfTels; ++i) {
        cin >> tmp;
        tels[i] = tmp;
    }

    std::sort(tels.begin(), tels.end());

    int numOfDmgTels;
    vector<int> out;
    cin >> numOfDmgTels;
    for (int i = 0; i < numOfDmgTels; ++i) {
        string dmgTel;
        vector<char> pattern(9);
        cin >> dmgTel;
        if(dmgTel.find('*') < 42){
            dmgTel = normalize(dmgTel);
        }
        for (size_t pos = 0; pos < 9; ++pos) {
            switch (dmgTel[pos]) {
                case('?'): {
                    pattern[pos] = 'o';
                    break;
                }
                default: {
                    pattern[pos] = dmgTel[pos];
                    break;
                }
            }
        }
        int count = 0;

        for(auto it = std::lower_bound(tels.begin(), tels.end(), [](const string &s1, const string &s2) {

        }); it != tels.end() && it != upper_bound(tels.begin(), tels.end()); it++){

        }
        for(string tel : tels) {
            bool ok = true;
            for (int pos = 0; pos < 9; ++pos) {
                if(pattern[pos] == 'o' || pattern[pos] == tel[pos]) continue;
                ok = false;
                break;
            }
            if(ok) ++count;
        }
        out.push_back(count);
    }

    for(int i : out)
        cout << i << '\n';

    return 0;
}